# Manual staking

### Install

1. Clone [https://gitlab.com/accumulatenetwork/core/staking/](https://gitlab.com/accumulatenetwork/core/staking/)
2. `cd staking`
3. Build the `staking-report` tool with `go build ./cmd/staking-report` or install it with `go install ./cmd/staking-report`

### Update the database

Run `./staking-report pull` to update the staking database. This pulls the staking data and token accounts from the network and stores them in a local database (`~/.accumulate/staking.db`). This is an incremental process and will only download records that have changed since the last pull.

### Determine the major block range

Run the following command with an appropriate starting value to display a table of major blocks:

```sh
accumulate get "dn.acme/anchors?start=${START}&count=50#chain/major-block" | jq -r '["Block","Time"], ["-----", "----"], (.items[] | [.blockIndex,.blockTime]) | @tsv'
```

The start block is 00:00:xxZ on the previous Friday and the end block is 00:00:xxZ on this Friday.

### Old report generator

Run `./staking-report old ${start} ${end}`, optionally with `--csv`. This outputs a table of staking accounts, balances, deposits, rewards, etc.

### New report generator

Run `./staking-report ${start} ${end} ${budget}`, optionally with `--csv`. This requires the weekly budget as an input. That can be calculated manually, or via Paul's staking spreadsheet. This command outputs the payout transaction body followed by a table of staking accounts, balances, deposits, rewards, etc.

### Building the report

1. Create a copy of the latest staking report in [Accumulate > Staking > Staking reports](https://drive.google.com/drive/u/0/folders/16P5azWAzeKv3kVqeGhu1mOtHJ6mg47tA) on Google drive.
2. Duplicate the latest "${month} ${day}" sheet, rename it, and move it to the front of the line (after the Process sheet).
3. Update the Pay Day Date (B1), Previous Pay Day Sheet (B2), and Total Tokens Issued (B9) cells.
4. Replace the table's values with the new values from the **old** report.
5. Move the "defidevs.acme | delegated | defidevs.acme/wacme-lp-incentives-curve" row to before the "defidevs.acme | coreValidator | defidevs.acme/stake" row, to fix problems with the **Effective Type** column.
6. Verify there are no highlighted cells in the Effective Type column.
7. For each set of rows with the same **Reward Account** (highlighted in red), adjust the **Corrections** column so that all rewards from the second+ row(s) are added to the first row. This consolidates outputs so there's only a single output per reward account.
8. Verify there are no highlighted cells in the 'header' block (check for errors).
9. Go to the **Validate** sheet and update the "${month} ${day}" cell (L1) to point to the new sheet.
10. Replace the table's values with the new values from the **new** report.
11. Verify any errors in the rewards (column N) and weighted balance (column P) are within acceptable limits. Differences greater than 0.0001 ACME will be highlighted.
12. Submit the payout using the body provided by the **new** report (which uses higher precision than the one generated by the spreadsheet).
